Attribute VB_Name = "modHHPopups"
' *****************************************************
' Code to subclass a Visual Basic form for
' WM_HELP messaging for HTML Help purposes
' Version 3.0e
' (c)September 1999, Delmar Computing Services
'
' Developed by David Liske, Tipton, Michigan, USA
' Microsoft HTML Help MVP
' http://www.vbexplorer.com/htmlhelp.asp
'
' ATTENTION:
' Due to the use of the AddressOf operator, this code
' *will* crash the Visual Basic IDE in Debug mode.
' If debugging of the application is necessary,
' uncomment the first Exit Sub in the HHSubclass routine.
' Again, this routine *cannot* be run in Debug mode.
'
' To use this module, the subclassed calling form
' needs to have the following methods included:
'
' Public Sub OnHelp(hWndControl As Long)
'
' Please send any performance or functionality
' modifications of this file to delmar@tc3net.com
' *****************************************************

Option Explicit

' Windows messaging
Private Const WM_HELP = &H53
Private Const WM_NCDESTROY = &H82

' Subclassing
Private Const GWL_WNDPROC = (-4)

' UDT for mouse cursor position
Private Type POINTAPI
  x As Long
  y As Long
End Type

Private Type HELPINFO
  cbSize As Long
  iContextType As Long
  iCtrlId As Long
  hItemHandle As Long
  dwContextId As Long
  MousePos As POINTAPI
End Type

Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Private Declare Function CallWindowProc Lib "user32" _
    Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, _
    ByVal hwnd As Long, _
    ByVal msgWinMessage As Long, _
    ByVal wParam As Long, _
    lParam As Any) As Long

Private Declare Sub CopyMemory Lib "kernel32" _
    Alias "RtlMoveMemory" (Dest As Any, _
    Source As Any, _
    ByVal nLen As Long)

Private Declare Function GetWindowLong Lib "user32" _
    Alias "GetWindowLongA" (ByVal hwnd As Long, _
    ByVal nIndex As Long) As Long
    
Private Declare Function SetWindowLong Lib "user32" _
    Alias "SetWindowLongA" (ByVal hwnd As Long, _
    ByVal nIndex As Long, _
    ByVal dwNewLong As Long) As Long

Private colHTMLHelp As New Collection

Private Function HHSubclassWndProc(ByVal hwnd As Long, _
  ByVal msgWinMessage As Long, ByVal wParam As Long, _
  ByVal lParam As Long) As Long

  Dim colhHelp As Object
    
  ' Loop through all the forms in the collection and use
  ' the handle to determing the message the form belongs to
  For Each colhHelp In colHTMLHelp
    If (colhHelp.hwnd = hwnd) Then
      Exit For
    End If
  Next colhHelp
  
  ' Track down which message was sent and run the
  ' appropriate procedure on the calling form
  Select Case (msgWinMessage)
        
  Case WM_HELP
    ' The WM_HELP message is sent whenever the user
    ' presses the F1 key.  It also occurs in response
    ' to What's This Help requests.
    Dim hlpHelpInfo As HELPINFO
    Call CopyMemory(hlpHelpInfo, ByVal lParam, Len(hlpHelpInfo))
    Call colhHelp.frm.OnHelp(hlpHelpInfo.hItemHandle)
        
  Case Else
    ' Let the message continue on its way
    HHSubclassWndProc = CallWindowProc _
        (colhHelp.lpPrevWndFunc, hwnd, msgWinMessage, _
        wParam, ByVal lParam)
    
  End Select

  If (msgWinMessage = WM_NCDESTROY) Then
    ' If the window no longer exists,
    ' get it out of the HHSubclass collection
    Dim intCount As Integer
    For intCount = 1 To colHTMLHelp.Count
      If (colhHelp Is colHTMLHelp(intCount)) Then
        Call colHTMLHelp.Remove(intCount)
        Exit For
      End If
    Next intCount
  End If

End Function

Public Sub HHSubclass(frm As Object)
    
  ' Uncomment this line in Debug mode (see the
  ' "Attention" section of the comment block for
  ' this module):
  ' Exit Sub
  
  Dim hHelp As New HTMLHelp
    
  ' Create the object as a form
  Set hHelp.frm = frm
  hHelp.hwnd = frm.hwnd
  hHelp.lpPrevWndFunc = GetWindowLong _
      (frm.hwnd, _
      GWL_WNDPROC)
    
  ' Replace the basic window procedure of the
  ' form calling this procedure
  Call SetWindowLong(frm.hwnd, _
      GWL_WNDPROC, _
      AddressOf HHSubclassWndProc)
    
  ' Put this form into the subclass collection
  ' we created in the Declarations section
  colHTMLHelp.Add hHelp

End Sub

Public Sub HHUnSubClass(frm As Object)
  
  Dim hHelp As New HTMLHelp
  
  ' Release the subclassed form
  Call SetWindowLong(frm.hwnd, _
      GWL_WNDPROC, hHelp.lpPrevWndFunc)
  
End Sub

